
Base Language - Feature #1885

fix and add necessary format string support

10/31/2012 02:35 PM - Greg Shah

Status: Closed Start date: 03/05/2013

Priority: Normal Due date: 09/04/2013

Assignee:  % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: Cleanup and Stablization for Server

Features

  

billable: No vendor_id: GCD

Description

Subtasks:

Feature # 2079: add missing conversion support for format string Closed

Bug # 2147: fix any runtime issues with format strings (server project) Closed

History

#1 - 03/05/2013 04:38 PM - Constantin Asofiei

There is at least one format string problem in the server. Looks like PUT fields can have a dynamic format, and any expression can be used:

def stream rpt.

def var ch as char.

find first book.

output stream rpt to put_test.txt.

PUT STREAM rpt book.book-title FORMAT "x(15)" + " ". /* this is a complex expression which gets evaluated at r

untime */

ch = "x(10)".

PUT STREAM rpt book.book-title FORMAT ch. /* this must be the ch var not the "ch" string. ch is evaluated at r

untime and if is not a valid format, some message is shown */

output stream rpt close.

 

I guess I'm taking this at least to fix the put field's format. I'll add another task to track the conversion support for this.

#2 - 03/05/2013 05:04 PM - Constantin Asofiei
- File ca_upd20130305g.zip added

This fixes the conversion problem, still need to expand PutField c'tors to accept character for the format... or, can we just call "toStringMessage()" for

the expression, so we will not duplicate all the c'tors which accept String format ?

#3 - 03/05/2013 05:24 PM - Greg Shah

Yes, using toStringMessage() is a great idea.

#4 - 03/06/2013 02:16 AM - Constantin Asofiei

- File ca_upd20130306a.zip added

This version emits the toStringMessage in case the format is a complex expression, for PUT field. Also, adds a TODO in PutField class, to validate

the format.

#5 - 03/06/2013 02:32 AM - Constantin Asofiei

- File deleted (ca_upd20130306a.zip)

#6 - 03/06/2013 02:32 AM - Constantin Asofiei

- File ca_upd20130306a.zip added

Correct version of progress.g

#7 - 03/06/2013 04:45 AM - Constantin Asofiei

0306a.zip has passed conversion regression testing (no changes in generated sources).

#8 - 03/06/2013 07:14 AM - Constantin Asofiei

0306a.zip was Committed to bzr revision 10252.

#9 - 04/25/2013 11:23 AM - Greg Shah

- Target version changed from Milestone 7 to Milestone 11

#10 - 05/06/2014 02:16 PM - Greg Shah

- Status changed from New to Closed

#11 - 11/16/2016 12:07 PM - Greg Shah

- Target version changed from Milestone 11 to Cleanup and Stablization for Server Features

Files

ca_upd20130305g.zip 267 KB 03/05/2013 Constantin Asofiei

ca_upd20130306a.zip 281 KB 03/06/2013 Constantin Asofiei
